#property  copyright "Copyright  2005, Yura Prokofiev"
#property  link      "Yura.prokofiev@gmail.com <------ thanks Altered by Perky"

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_color2  LimeGreen
#property  indicator_color3  Red
 
extern int FastADRsi=3;
extern int slowADRsi=14;
extern int WidthLine=1;
extern color colorup=MediumSeaGreen;
extern color colordown=Salmon;
double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];
int count=0;
int barz=0;

#define SignalName "adrsicvdv"

int init()
  {
   
   
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4,Red);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4,LimeGreen);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);

   IndicatorShortName("AdrsiCVDV");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);

   return(0);
  }


int deinit(){
DeleteObjects();

return(0);}

int start()
  {
   //int     period=10;
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current,prevp,old;
   

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

Comment (limit);
   for(int i=0; i<limit; i++)
    {  
      ExtBuffer0[i]=(iCustom(NULL, 0, "adaptive RSI",FastADRsi,0,i))-(iCustom(NULL, 0, "adaptive RSI",slowADRsi,14,0,i));
         
      
      
    }


   bool up=true;
  
  for(i=limit-2; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
     
          if(ExtBuffer0[i]>0&&ExtBuffer0[i+1]>0 && ExtBuffer0[i+2]<0)DrawLine(i, "Up");
          if(ExtBuffer0[i]<0&&ExtBuffer0[i+1]<0 && ExtBuffer0[i+2]>0)DrawLine(i, "Down");
         
      if (((current<0)&&(prev>0))||(current<0))   up= false;    
      if (((current>0)&&(prev<0))||(current>0))   up= true;
      
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
        
       else
         {
          ExtBuffer1[i]=current;
          ExtBuffer2[i]=0.0;
         }
     
     }

   return(0);
  }
  
  
  
  
  void DrawLine(int i,string type)
{    

     if (barz!=Bars) {PlaySound("news.wav");barz=Bars;}
      count++;
      string name = StringConcatenate(SignalName,count);
      ObjectCreate(name,OBJ_VLINE,0,Time[i],1);
      if (type=="Up")
         {
           
            ObjectSet(name, OBJPROP_WIDTH, WidthLine);
            ObjectSet(name, OBJPROP_COLOR, colorup);
         }
      else if (type=="Down")
         {
            ObjectSet(name, OBJPROP_WIDTH, WidthLine);
            ObjectSet(name, OBJPROP_COLOR, colordown);
         }
         }
          
          
          
          
 void DeleteObjects(){

 for (count = 0; count < ObjectsTotal(); count++) {
      if ((StringFind(ObjectName(count),SignalName) == 0)) {
         ObjectDelete(ObjectName(count));
         WindowRedraw();
        count--;
       }
         }
         } 